t3008: find test-tool through path lookup
[git/raj.git] / git-submodule.sh
blob65d62c888c8f2288ca276b28744f51f773bee8f2
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 require_init=
38 files=
39 remote=
40 nofetch=
41 update=
42 prefix=
43 custom_name=
44 depth=
45 progress=
46 dissociate=
48 die_if_unmatched ()
50 if test "$1" = "#unmatched"
51 then
52 exit ${2:-1}
57 # Print a submodule configuration setting
59 # $1 = submodule name
60 # $2 = option name
61 # $3 = default value
63 # Checks in the usual git-config places first (for overrides),
64 # otherwise it falls back on .gitmodules. This allows you to
65 # distribute project-wide defaults in .gitmodules, while still
66 # customizing individual repositories if necessary. If the option is
67 # not in .gitmodules either, print a default value.
69 get_submodule_config () {
70 name="$1"
71 option="$2"
72 default="$3"
73 value=$(git config submodule."$name"."$option")
74 if test -z "$value"
75 then
76 value=$(git submodule--helper config submodule."$name"."$option")
78 printf '%s' "${value:-$default}"
81 isnumber()
83 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
86 # Given a full hex object ID, is this the zero OID?
87 is_zero_oid () {
88 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
91 # Sanitize the local git environment for use within a submodule. We
92 # can't simply use clear_local_git_env since we want to preserve some
93 # of the settings from GIT_CONFIG_PARAMETERS.
94 sanitize_submodule_env()
96 save_config=$GIT_CONFIG_PARAMETERS
97 clear_local_git_env
98 GIT_CONFIG_PARAMETERS=$save_config
99 export GIT_CONFIG_PARAMETERS
103 # Add a new submodule to the working tree, .gitmodules and the index
105 # $@ = repo path
107 # optional branch is stored in global branch variable
109 cmd_add()
111 # parse $args after "submodule ... add".
112 reference_path=
113 while test $# -ne 0
115 case "$1" in
116 -b | --branch)
117 case "$2" in '') usage ;; esac
118 branch=$2
119 shift
121 -f | --force)
122 force=$1
124 -q|--quiet)
125 GIT_QUIET=1
127 --progress)
128 progress=1
130 --reference)
131 case "$2" in '') usage ;; esac
132 reference_path=$2
133 shift
135 --reference=*)
136 reference_path="${1#--reference=}"
138 --dissociate)
139 dissociate=1
141 --name)
142 case "$2" in '') usage ;; esac
143 custom_name=$2
144 shift
146 --depth)
147 case "$2" in '') usage ;; esac
148 depth="--depth=$2"
149 shift
151 --depth=*)
152 depth=$1
155 shift
156 break
159 usage
162 break
164 esac
165 shift
166 done
168 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
169 then
170 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
173 if test -n "$reference_path"
174 then
175 is_absolute_path "$reference_path" ||
176 reference_path="$wt_prefix$reference_path"
178 reference="--reference=$reference_path"
181 repo=$1
182 sm_path=$2
184 if test -z "$sm_path"; then
185 sm_path=$(printf '%s\n' "$repo" |
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
189 if test -z "$repo" || test -z "$sm_path"; then
190 usage
193 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
195 # assure repo is absolute or relative to parent
196 case "$repo" in
197 ./*|../*)
198 test -z "$wt_prefix" ||
199 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
201 # dereference source url relative to parent's url
202 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
204 *:*|/*)
205 # absolute url
206 realrepo=$repo
209 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
211 esac
213 # normalize path:
214 # multiple //; leading ./; /./; /../; trailing /
215 sm_path=$(printf '%s/\n' "$sm_path" |
216 sed -e '
217 s|//*|/|g
218 s|^\(\./\)*||
219 s|/\(\./\)*|/|g
220 :start
221 s|\([^/]*\)/\.\./||
222 tstart
223 s|/*$||
225 if test -z "$force"
226 then
227 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
228 die "$(eval_gettext "'\$sm_path' already exists in the index")"
229 else
230 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
234 if test -z "$force" &&
235 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
236 then
237 eval_gettextln "The following path is ignored by one of your .gitignore files:
238 \$sm_path
239 Use -f if you really want to add it." >&2
240 exit 1
243 if test -n "$custom_name"
244 then
245 sm_name="$custom_name"
246 else
247 sm_name="$sm_path"
250 if ! git submodule--helper check-name "$sm_name"
251 then
252 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
255 # perhaps the path exists and is already a git repo, else clone it
256 if test -e "$sm_path"
257 then
258 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
259 then
260 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
261 else
262 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
265 else
266 if test -d ".git/modules/$sm_name"
267 then
268 if test -z "$force"
269 then
270 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
271 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
272 die "$(eval_gettextln "\
273 If you want to reuse this local git directory instead of cloning again from
274 \$realrepo
275 use the '--force' option. If the local git directory is not the correct repo
276 or you are unsure what this means choose another name with the '--name' option.")"
277 else
278 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
281 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
283 sanitize_submodule_env
284 cd "$sm_path" &&
285 # ash fails to wordsplit ${branch:+-b "$branch"...}
286 case "$branch" in
287 '') git checkout -f -q ;;
288 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
289 esac
290 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
292 git config submodule."$sm_name".url "$realrepo"
294 git add --no-warn-embedded-repo $force "$sm_path" ||
295 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
297 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
298 git submodule--helper config submodule."$sm_name".url "$repo" &&
299 if test -n "$branch"
300 then
301 git submodule--helper config submodule."$sm_name".branch "$branch"
302 fi &&
303 git add --force .gitmodules ||
304 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
306 # NEEDSWORK: In a multi-working-tree world, this needs to be
307 # set in the per-worktree config.
308 if git config --get submodule.active >/dev/null
309 then
310 # If the submodule being adding isn't already covered by the
311 # current configured pathspec, set the submodule's active flag
312 if ! git submodule--helper is-active "$sm_path"
313 then
314 git config submodule."$sm_name".active "true"
316 else
317 git config submodule."$sm_name".active "true"
322 # Execute an arbitrary command sequence in each checked out
323 # submodule
325 # $@ = command to execute
327 cmd_foreach()
329 # parse $args after "submodule ... foreach".
330 while test $# -ne 0
332 case "$1" in
333 -q|--quiet)
334 GIT_QUIET=1
336 --recursive)
337 recursive=1
340 usage
343 break
345 esac
346 shift
347 done
349 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
353 # Register submodules in .git/config
355 # $@ = requested paths (default to all)
357 cmd_init()
359 # parse $args after "submodule ... init".
360 while test $# -ne 0
362 case "$1" in
363 -q|--quiet)
364 GIT_QUIET=1
367 shift
368 break
371 usage
374 break
376 esac
377 shift
378 done
380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
384 # Unregister submodules from .git/config and remove their work tree
386 cmd_deinit()
388 # parse $args after "submodule ... deinit".
389 deinit_all=
390 while test $# -ne 0
392 case "$1" in
393 -f|--force)
394 force=$1
396 -q|--quiet)
397 GIT_QUIET=1
399 --all)
400 deinit_all=t
403 shift
404 break
407 usage
410 break
412 esac
413 shift
414 done
416 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
419 is_tip_reachable () (
420 sanitize_submodule_env &&
421 cd "$1" &&
422 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
423 test -z "$rev"
426 fetch_in_submodule () (
427 sanitize_submodule_env &&
428 cd "$1" &&
429 case "$2" in
431 git fetch ;;
433 shift
434 git fetch $(get_default_remote) "$@" ;;
435 esac
439 # Update each submodule path to correct revision, using clone and checkout as needed
441 # $@ = requested paths (default to all)
443 cmd_update()
445 # parse $args after "submodule ... update".
446 while test $# -ne 0
448 case "$1" in
449 -q|--quiet)
450 GIT_QUIET=1
453 GIT_QUIET=0
455 --progress)
456 progress=1
458 -i|--init)
459 init=1
461 --require-init)
462 init=1
463 require_init=1
465 --remote)
466 remote=1
468 -N|--no-fetch)
469 nofetch=1
471 -f|--force)
472 force=$1
474 -r|--rebase)
475 update="rebase"
477 --reference)
478 case "$2" in '') usage ;; esac
479 reference="--reference=$2"
480 shift
482 --reference=*)
483 reference="$1"
485 --dissociate)
486 dissociate=1
488 -m|--merge)
489 update="merge"
491 --recursive)
492 recursive=1
494 --checkout)
495 update="checkout"
497 --recommend-shallow)
498 recommend_shallow="--recommend-shallow"
500 --no-recommend-shallow)
501 recommend_shallow="--no-recommend-shallow"
503 --depth)
504 case "$2" in '') usage ;; esac
505 depth="--depth=$2"
506 shift
508 --depth=*)
509 depth=$1
511 -j|--jobs)
512 case "$2" in '') usage ;; esac
513 jobs="--jobs=$2"
514 shift
516 --jobs=*)
517 jobs=$1
520 shift
521 break
524 usage
527 break
529 esac
530 shift
531 done
533 if test -n "$init"
534 then
535 cmd_init "--" "$@" || return
539 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
540 ${progress:+"--progress"} \
541 ${wt_prefix:+--prefix "$wt_prefix"} \
542 ${prefix:+--recursive-prefix "$prefix"} \
543 ${update:+--update "$update"} \
544 ${reference:+"$reference"} \
545 ${dissociate:+"--dissociate"} \
546 ${depth:+--depth "$depth"} \
547 ${require_init:+--require-init} \
548 $recommend_shallow \
549 $jobs \
550 "$@" || echo "#unmatched" $?
551 } | {
552 err=
553 while read -r quickabort sha1 just_cloned sm_path
555 die_if_unmatched "$quickabort" "$sha1"
557 git submodule--helper ensure-core-worktree "$sm_path"
559 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
561 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
563 if test $just_cloned -eq 1
564 then
565 subsha1=
566 else
567 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
568 git rev-parse --verify HEAD) ||
569 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
572 if test -n "$remote"
573 then
574 branch=$(git submodule--helper remote-branch "$sm_path")
575 if test -z "$nofetch"
576 then
577 # Fetch remote before determining tracking $sha1
578 fetch_in_submodule "$sm_path" $depth ||
579 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
581 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
582 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
583 git rev-parse --verify "${remote_name}/${branch}") ||
584 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
587 if test "$subsha1" != "$sha1" || test -n "$force"
588 then
589 subforce=$force
590 # If we don't already have a -f flag and the submodule has never been checked out
591 if test -z "$subsha1" && test -z "$force"
592 then
593 subforce="-f"
596 if test -z "$nofetch"
597 then
598 # Run fetch only if $sha1 isn't present or it
599 # is not reachable from a ref.
600 is_tip_reachable "$sm_path" "$sha1" ||
601 fetch_in_submodule "$sm_path" $depth ||
602 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
604 # Now we tried the usual fetch, but $sha1 may
605 # not be reachable from any of the refs
606 is_tip_reachable "$sm_path" "$sha1" ||
607 fetch_in_submodule "$sm_path" $depth "$sha1" ||
608 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
611 must_die_on_failure=
612 case "$update_module" in
613 checkout)
614 command="git checkout $subforce -q"
615 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
618 rebase)
619 command="git rebase"
620 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
621 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
622 must_die_on_failure=yes
624 merge)
625 command="git merge"
626 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
627 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
628 must_die_on_failure=yes
631 command="${update_module#!}"
632 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
633 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
634 must_die_on_failure=yes
637 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
638 esac
640 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
641 then
642 say "$say_msg"
643 elif test -n "$must_die_on_failure"
644 then
645 die_with_status 2 "$die_msg"
646 else
647 err="${err};$die_msg"
648 continue
652 if test -n "$recursive"
653 then
655 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
656 wt_prefix=
657 sanitize_submodule_env
658 cd "$sm_path" &&
659 eval cmd_update
661 res=$?
662 if test $res -gt 0
663 then
664 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
665 if test $res -ne 2
666 then
667 err="${err};$die_msg"
668 continue
669 else
670 die_with_status $res "$die_msg"
674 done
676 if test -n "$err"
677 then
678 OIFS=$IFS
679 IFS=';'
680 for e in $err
682 if test -n "$e"
683 then
684 echo >&2 "$e"
686 done
687 IFS=$OIFS
688 exit 1
694 # Show commit summary for submodules in index or working tree
696 # If '--cached' is given, show summary between index and given commit,
697 # or between working tree and given commit
699 # $@ = [commit (default 'HEAD'),] requested paths (default all)
701 cmd_summary() {
702 summary_limit=-1
703 for_status=
704 diff_cmd=diff-index
706 # parse $args after "submodule ... summary".
707 while test $# -ne 0
709 case "$1" in
710 --cached)
711 cached="$1"
713 --files)
714 files="$1"
716 --for-status)
717 for_status="$1"
719 -n|--summary-limit)
720 summary_limit="$2"
721 isnumber "$summary_limit" || usage
722 shift
724 --summary-limit=*)
725 summary_limit="${1#--summary-limit=}"
726 isnumber "$summary_limit" || usage
729 shift
730 break
733 usage
736 break
738 esac
739 shift
740 done
742 test $summary_limit = 0 && return
744 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
745 then
746 head=$rev
747 test $# = 0 || shift
748 elif test -z "$1" || test "$1" = "HEAD"
749 then
750 # before the first commit: compare with an empty tree
751 head=$(git hash-object -w -t tree --stdin </dev/null)
752 test -z "$1" || shift
753 else
754 head="HEAD"
757 if [ -n "$files" ]
758 then
759 test -n "$cached" &&
760 die "$(gettext "The --cached option cannot be used with the --files option")"
761 diff_cmd=diff-files
762 head=
765 cd_to_toplevel
766 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
767 # Get modified modules cared by user
768 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
769 sane_egrep '^:([0-7]* )?160000' |
770 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
772 # Always show modules deleted or type-changed (blob<->module)
773 if test "$status" = D || test "$status" = T
774 then
775 printf '%s\n' "$sm_path"
776 continue
778 # Respect the ignore setting for --for-status.
779 if test -n "$for_status"
780 then
781 name=$(git submodule--helper name "$sm_path")
782 ignore_config=$(get_submodule_config "$name" ignore none)
783 test $status != A && test $ignore_config = all && continue
785 # Also show added or modified modules which are checked out
786 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
787 printf '%s\n' "$sm_path"
788 done
791 test -z "$modules" && return
793 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
794 sane_egrep '^:([0-7]* )?160000' |
795 cut -c2- |
796 while read -r mod_src mod_dst sha1_src sha1_dst status name
798 if test -z "$cached" &&
799 is_zero_oid $sha1_dst
800 then
801 case "$mod_dst" in
802 160000)
803 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
805 100644 | 100755 | 120000)
806 sha1_dst=$(git hash-object $name)
808 000000)
809 ;; # removed
811 # unexpected type
812 eval_gettextln "unexpected mode \$mod_dst" >&2
813 continue ;;
814 esac
816 missing_src=
817 missing_dst=
819 test $mod_src = 160000 &&
820 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
821 missing_src=t
823 test $mod_dst = 160000 &&
824 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
825 missing_dst=t
827 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
829 total_commits=
830 case "$missing_src,$missing_dst" in
832 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
835 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
837 t,t)
838 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
841 errmsg=
842 total_commits=$(
843 if test $mod_src = 160000 && test $mod_dst = 160000
844 then
845 range="$sha1_src...$sha1_dst"
846 elif test $mod_src = 160000
847 then
848 range=$sha1_src
849 else
850 range=$sha1_dst
852 GIT_DIR="$name/.git" \
853 git rev-list --first-parent $range -- | wc -l
855 total_commits=" ($(($total_commits + 0)))"
857 esac
859 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
860 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
861 if test $status = T
862 then
863 blob="$(gettext "blob")"
864 submodule="$(gettext "submodule")"
865 if test $mod_dst = 160000
866 then
867 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
868 else
869 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
871 else
872 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
874 if test -n "$errmsg"
875 then
876 # Don't give error msg for modification whose dst is not submodule
877 # i.e. deleted or changed to blob
878 test $mod_dst = 160000 && echo "$errmsg"
879 else
880 if test $mod_src = 160000 && test $mod_dst = 160000
881 then
882 limit=
883 test $summary_limit -gt 0 && limit="-$summary_limit"
884 GIT_DIR="$name/.git" \
885 git log $limit --pretty='format: %m %s' \
886 --first-parent $sha1_src...$sha1_dst
887 elif test $mod_dst = 160000
888 then
889 GIT_DIR="$name/.git" \
890 git log --pretty='format: > %s' -1 $sha1_dst
891 else
892 GIT_DIR="$name/.git" \
893 git log --pretty='format: < %s' -1 $sha1_src
895 echo
897 echo
898 done
901 # List all submodules, prefixed with:
902 # - submodule not initialized
903 # + different revision checked out
905 # If --cached was specified the revision in the index will be printed
906 # instead of the currently checked out revision.
908 # $@ = requested paths (default to all)
910 cmd_status()
912 # parse $args after "submodule ... status".
913 while test $# -ne 0
915 case "$1" in
916 -q|--quiet)
917 GIT_QUIET=1
919 --cached)
920 cached=1
922 --recursive)
923 recursive=1
926 shift
927 break
930 usage
933 break
935 esac
936 shift
937 done
939 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
942 # Sync remote urls for submodules
943 # This makes the value for remote.$remote.url match the value
944 # specified in .gitmodules.
946 cmd_sync()
948 while test $# -ne 0
950 case "$1" in
951 -q|--quiet)
952 GIT_QUIET=1
953 shift
955 --recursive)
956 recursive=1
957 shift
960 shift
961 break
964 usage
967 break
969 esac
970 done
972 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
975 cmd_absorbgitdirs()
977 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
980 # This loop parses the command line arguments to find the
981 # subcommand name to dispatch. Parsing of the subcommand specific
982 # options are primarily done by the subcommand implementations.
983 # Subcommand specific options such as --branch and --cached are
984 # parsed here as well, for backward compatibility.
986 while test $# != 0 && test -z "$command"
988 case "$1" in
989 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
990 command=$1
992 -q|--quiet)
993 GIT_QUIET=1
995 -b|--branch)
996 case "$2" in
998 usage
1000 esac
1001 branch="$2"; shift
1003 --cached)
1004 cached="$1"
1007 break
1010 usage
1013 break
1015 esac
1016 shift
1017 done
1019 # No command word defaults to "status"
1020 if test -z "$command"
1021 then
1022 if test $# = 0
1023 then
1024 command=status
1025 else
1026 usage
1030 # "-b branch" is accepted only by "add"
1031 if test -n "$branch" && test "$command" != add
1032 then
1033 usage
1036 # "--cached" is accepted only by "status" and "summary"
1037 if test -n "$cached" && test "$command" != status && test "$command" != summary
1038 then
1039 usage
1042 "cmd_$command" "$@"